﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.Odbc;
using System.Collections;
using System.IO;

namespace BarCodeScanner
{
    public partial class BarcodeCounter : Form
    {
        Form parForm;//form Login.cs
        string connStr;//connection string
        OdbcCommand com;
        OdbcConnection conn;
        OdbcDataAdapter da;
        DataTable dt;
        public DataSet ds;//used also in StudentList.cs
        public BindingSource tblBS;
        BindingSource tblBS_CourseResult;//used to bind dgView_Result
        CreateTables ct;
        StudentList sl;
        Remarks remark;
        string passwordString;
        string dateTableName;
        string stuTableName;
        string courseName = "";
        int formMode;
        public Boolean openSLornot = true; //used to control Student List open or close, make sure only one StudentList.cs run
        string errorMessage;

        private String getTodayDate()
        {
            string year = DateTime.Today.Year.ToString();
            string  month = DateTime.Today.Month.ToString();
            string day = DateTime.Today.Day.ToString();
            return year + "-" + month + "-" + day;
        } 

        public BarcodeCounter(Form f,string s,string ps,int mode)//Params:Parent Form,connection string,passwordString,mode
        {
            parForm = f;
            connStr = s;
            conn = new OdbcConnection(connStr);
            passwordString = ps;
            ct = new CreateTables(this, connStr);//construct a CreateTable.cs form
            remark = new Remarks(this);//forget Card Student form
            formMode = mode;//mode=1 is student mode; mode=2 is professor mode
            InitializeComponent();
        }

        private void BarcodeCounter_Load(object sender, EventArgs e)
        {
            if (formMode == 1)//student mode (normal mode)
            {
                labelSwitchMode.Text = "Switch to Professor Mode";
                tabControl1.Visible = false;
                this.Width = 230;
                this.Height = 325;
                this.FormBorderStyle = FormBorderStyle.FixedSingle;

            }
            else// professor mode (all functions work)
            {
                labelSwitchMode.Text = "Switch to Student Mode";
                tabControl1.Visible = true;
                this.Width = 442;
                this.Height = 588;
                this.FormBorderStyle = FormBorderStyle.Sizable;
            }

            //tool tips
            toolTip_BarcodeCount.SetToolTip(this.btnAddnewcourse, "Add new course(s)");
            toolTip_BarcodeCount.SetToolTip(this.btnDropCourse, "Drop the current course");
            toolTip_BarcodeCount.SetToolTip(this.btnStudentList, "Open/Close Student List");
            toolTip_BarcodeCount.SetToolTip(this.btnRemark, "Store students who forgot bring their cards");
        }

        //control stwitching between 2 mode
        private void labelSwitchMode_Click(object sender, EventArgs e)
        {//mode=1 is student mode; mode=2 is professor mode
            if (formMode / 2 == 0) //the student Mode->professor mode
            {
                Password pw = new Password(this, passwordString);
                DialogResult result = pw.ShowDialog();
                if (result == DialogResult.OK)
                {
                    labelSwitchMode.Text = "Switch to Student Mode";
                    gbUser.Text = "(Professor Mode)";
                    tabControl1.Visible = true;
                    this.Width = 442;
                    this.Height = 588;
                    formMode = 2;
                    this.FormBorderStyle = FormBorderStyle.Sizable;
                }
            }
            else//professor mode->student mode
            {
                if (openSLornot == false)
                {
                    sl.Close();
                }
                labelSwitchMode.Text = "Switch to Professor Mode";
                gbUser.Text = "(Student Mode)";
                tabControl1.Visible = false;
                this.Width = 230;
                this.Height = 325;
                formMode = 1;
                this.FormBorderStyle = FormBorderStyle.FixedSingle;
            }
        }

        //update combobox's course list
        private void BarcodeCounter_VisibleChanged(object sender, EventArgs e)
        {
            updateCourseList();
            comboBoxCourseList.Text = courseName;
        }

        //update combobox's course list
        private void updateCourseList()
        {
            try
            {
                //com = new OdbcCommand("SELECT * FROM courselist_nameInfo", conn);
                com = new OdbcCommand("SHOW tables;", conn);
                da = new OdbcDataAdapter(com);
                dt = new DataTable();
                da.Fill(dt);
                comboBoxCourseList.Items.Clear();
                string[] courseName;
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    //Name of new table will be "stu_courseName" and "date_courseName"
                    courseName = dt.Rows[i][0].ToString().Split(new char[] { '_' }, 2);
                    if (courseName.Length > 1 && (courseName[0] == "stu" || courseName[0] == "date"))//maybe other datatable existing in the database
                    {
                        if (!comboBoxCourseList.Items.Contains(courseName[1]))
                        {
                            comboBoxCourseList.Items.Add(courseName[1]);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                errorMessage = ex.Message;
                MessageBox.Show(errorMessage);
                if (conn.State == ConnectionState.Open)
                { conn.Close(); }
            }
        }

        private void btnAddnewcourse_Click(object sender, EventArgs e)//show createTable.cs
        {
            MessageBox.Show("are you ok?");
            this.Hide();
            ct.Show();

        }

        //drop a course
        private void btnDropCourse_Click(object sender, EventArgs e)
        {
            DialogResult r = MessageBox.Show("Are you sure you want to DELETE this course?\n\n The records can NOT be recover!!!", "Question", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if (r == DialogResult.Yes)
            {
                try
                {
                    //drop 2 tables
                    com = new OdbcCommand("DROP TABLE " + stuTableName + ";", conn);
                    conn.Open();
                    com.ExecuteNonQuery();
                    conn.Close();
                    com = new OdbcCommand("DROP TABLE " + dateTableName + ";", conn);
                    conn.Open();
                    com.ExecuteNonQuery();
                    conn.Close();

                    //drop current item
                    comboBoxCourseList.Items.Remove(comboBoxCourseList.Text);

                    //reset all the components
                    tblBS.Dispose();
                    textBoxID.Text = "";
                    textBoxFN.Text = "";
                    textBoxLN.Text = "";
                    textBoxSN.Text = "";
                    labelAttendance.Text = "0";
                    tabControl1.SelectedIndex = 0;
                    labelStudNum.Text = "0";

                    //clear data gridview
                    dgViewDate.DataSource = null;

                    //unenable 3 parts and some buttons
                    gbUser.Enabled = false;
                    dgViewDate.Enabled = false;
                    tabControl1.Enabled = false;
                    btnDropCourse.Enabled = false;
                    btnStudentList.Enabled = false;
                    btnRemark.Enabled = false;

                    //refresh conponents in studentList.cs
                    if (openSLornot == false)
                    {
                        sl.dgView.DataSource = null;
                        sl.dgView.Refresh();
                        sl.bindingNavigator1.BindingSource = null;
                        sl.bindingNavigator1.Refresh();
                    }

                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    if (conn.State == ConnectionState.Open)
                    { conn.Close(); }
                }
            }
        }

        //add some remark to this course
        private void btnRemark_Click(object sender, EventArgs e)
        {
            remark.Show();
        }

        //all the components will be activated
        private void comboBoxCourseList_SelectedIndexChanged(object sender, EventArgs e)
        {
            //after one course being chosen, enable the main function
            tabControl1.Enabled = true;
            gbUser.Enabled = true;

            //define 2 tables'name
            courseName = comboBoxCourseList.Text;
            stuTableName = "stu_" + courseName;
            dateTableName = "date_" + courseName;

            //clear all textbox
            textBoxID.Text = "";
            textBoxFN.Text = "";
            textBoxLN.Text = "";
            textBoxSN.Text = "";
            if (openSLornot == false)//if sutdent list table is open, close it
            {
                sl.Close();
            }

            BindingData();//binding data
            BindingTextBox();//binding textBox 
            ShowDateInformation();
            CountPersonalAttendance();
            ShowDayPersonCount();
            
            //put the cursor in the ID textbox and select all content
            textBoxID.Focus();
            textBoxID.SelectAll();

            //enable show student list button and drop course button
            btnStudentList.Enabled = true;
            btnDropCourse.Enabled = true;
            btnRemark.Enabled = true;
            remark.tbxForgetCardStudent.Text = null;

            
            
        }

        //used to binding studentList, put all students' information into a data table.
        //binding students' information table to a public BindingSource tblBS
        public void BindingData()
        {
            try
            {
                com = new OdbcCommand("SELECT * FROM "+stuTableName, conn);
                da = new OdbcDataAdapter(com);
                ds = new DataSet();
                da.Fill(ds,"StudentList");
                ds.Tables["StudentList"].Columns["id"].Unique = true;
                ds.Tables["StudentList"].Columns["Studentnumber"].Unique = true;
                ds.Tables["StudentList"].Columns["id"].AllowDBNull = false;
                ds.Tables["StudentList"].Columns["Studentnumber"].AllowDBNull = false;
                tblBS = new BindingSource();
                tblBS.DataSource = ds.Tables["StudentList"];
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                if (conn.State == ConnectionState.Open)
                { conn.Close(); }
            }
        }

        //binding the public BindingSource tblBS to 4 information textboxes
        public void BindingTextBox()
        {
            try
            {
                textBoxID.DataBindings.Clear();
                textBoxFN.DataBindings.Clear();
                textBoxLN.DataBindings.Clear();
                textBoxSN.DataBindings.Clear();
                textBoxID.DataBindings.Add(new Binding("Text", tblBS, "ID"));
                textBoxFN.DataBindings.Add(new Binding("Text", tblBS, "FirstName"));
                textBoxLN.DataBindings.Add(new Binding("Text", tblBS, "LastName"));
                textBoxSN.DataBindings.Add(new Binding("Text", tblBS, "StudentNumber")); 
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message);
            }
        }

        private void dgViewDate_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            tbxDeleteDate.Text = dgViewDate.CurrentCell.Value.ToString().Substring(0,10);
            btnDelete_Appointment.Enabled = true;
        }

        //binding date information of this student to datagridview date
        public void ShowDateInformation()
        {
            try
            {
                com = new OdbcCommand("SELECT date FROM " + dateTableName + " WHERE ID='" + textBoxID.Text.Trim() + "'", conn);
                da = new OdbcDataAdapter(com);
                dt = new DataTable();
                da.Fill(dt);              
                dgViewDate.DataSource = dt; 
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                if (conn.State == ConnectionState.Open)
                { conn.Close(); }
            }
        }

        //show personal attendance (Update labelAttendance)
        public void CountPersonalAttendance()
        {
            labelAttendance.Text = dgViewDate.RowCount.ToString();
        }

        //show current how many students came (Update labelStudNum)
        public void ShowDayPersonCount()
        {
            string dateToday = getTodayDate();
            try
            {
                com = new OdbcCommand("SELECT * FROM " + dateTableName + " WHERE date='" + dateToday + "'", conn);
                da = new OdbcDataAdapter(com);
                dt = new DataTable();
                da.Fill(dt);
                labelStudNum.Text = dt.Rows.Count.ToString();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                if (conn.State == ConnectionState.Open)
                { conn.Close(); }
            }
        }

        //event happened, when scan card and press "enter"
        private void textBoxID_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                //if the databinding of textBoxID does not been clear, the current data in tblBS will be changed
                textBoxID.DataBindings.Clear();
                //find this student from the BindingSource tblBS
                tblBS.Position = tblBS.Find("ID", textBoxID.Text.Trim());
                ScanningCard();
                textBoxID.SelectAll();
            }
        }

        private void ScanningCard()
        {
            string dateToday = getTodayDate();
            try
            {
                //make sure he's a new student or an already existed one
                com = new OdbcCommand("SELECT * FROM "+stuTableName+" WHERE ID='" + textBoxID.Text.Trim() + "'", conn);
                da = new OdbcDataAdapter(com);
                dt = new DataTable();
                da.Fill(dt);
                if (dt.Rows.Count == 0)//a new student
                {
                    MessageBox.Show("You are new!\n\nPlease contact professor to add your information!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    //clear the information box
                    textBoxFN.DataBindings.Clear();
                    textBoxLN.DataBindings.Clear();
                    textBoxSN.DataBindings.Clear();
                    textBoxFN.Text = "";
                    textBoxLN.Text = "";
                    textBoxSN.Text = "";
                }
                else//existing student, make sure he/she has already scanned or not
                {
                    com = new OdbcCommand("SELECT * FROM " + dateTableName + " WHERE ID='" + textBoxID.Text.Trim() + "' AND date='" + dateToday + "'", conn);
                    da = new OdbcDataAdapter(com);
                    dt = new DataTable();
                    da.Fill(dt);
                    if (dt.Rows.Count == 0)//has not scanned,insert new date information to his/her record,
                    {
                        da.InsertCommand = new OdbcCommand("INSERT INTO " + dateTableName + "(date,ID) VALUES('" + dateToday + "','" + textBoxID.Text.Trim() + "')", conn);
                        conn.Open();
                        da.InsertCommand.ExecuteNonQuery();
                        conn.Close();
                    }
                    //update date datagridview
                    ShowDateInformation();
                    //change personal attendance
                    CountPersonalAttendance();
                    //change total Student Number came today
                    ShowDayPersonCount();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                if (conn.State == ConnectionState.Open)
                { conn.Close(); }
            }
        }

        //control the edit checkbox, students can only edit their name information
        private void editCheck_CheckedChanged(object sender, EventArgs e)
        {   //cannot edit without ID information
            if (textBoxID.Text.ToString().Trim() == "")
            {
                editCheck.Checked = false;
            }
            if (editCheck.Checked == true)
            {
                textBoxFN.Focus();
                textBoxFN.ReadOnly = false;
                textBoxLN.ReadOnly = false;
                textBoxID.ReadOnly = true;//ID cannot be changed during name editing
                editCheck.Enabled = false;
            }
            else
            {
                textBoxID.Focus();
                textBoxFN.ReadOnly = true;
                textBoxLN.ReadOnly = true;
                textBoxID.ReadOnly = false;
            }
        }

        //save changes of lastname and firstname
        private void btnSave_Click(object sender, EventArgs e)
        {
            string fnValue = "'" + textBoxFN.Text.Trim() + "'";
            string lnValue = "'" + textBoxLN.Text.Trim() + "'";
            if (fnValue == "''"){ fnValue = "NULL";}
            if (lnValue == "''"){ lnValue = "NULL";}
            try
            {
                da.UpdateCommand = new OdbcCommand("UPDATE "+stuTableName+" SET FirstName=" + fnValue + ",LastName=" + lnValue + " WHERE ID='" + textBoxID.Text.Trim()+"'", conn);
                conn.Open();
                da.UpdateCommand.ExecuteNonQuery();
                conn.Close();
                editCheck.Checked = false;
                if (openSLornot == false)
                {
                    sl.dgView.Refresh();
                }
                editCheck.Enabled = true;
                editCheck.Checked = false;
                
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                if (conn.State == ConnectionState.Open)
                { conn.Close(); }
            }
            
        }

        //open or close studnet list "StudentList.cs", to make sure only one StudentList.cs window run
        private void btnStudentList_Click(object sender, EventArgs e)
        {
            try
            {
                if (openSLornot == true)//open student list table
                {
                    //open student list
                    sl = new StudentList(this, connStr, comboBoxCourseList.Text);
                    sl.Show();
                    btnStudentList.Text = "Cl&ose List";
                    openSLornot = false;
                }
                else //close student list table
                {
                    sl.Close();
                    btnStudentList.Text = "&Open List";
                    openSLornot = true;
                }
            }
            catch (Exception ex)
            {
                errorMessage = ex.Message;
            }

        }

         //update student number(in number update tag)
        private void btnOK_UpdateID_Click(object sender, EventArgs e)
        {
            try
            {
                da.UpdateCommand = new OdbcCommand("UPDATE " + stuTableName + " SET ID='" + tbxUpdateID.Text.Trim() + "' WHERE ID='" + textBoxID.Text.Trim() + "'", conn);
                conn.Open();
                da.UpdateCommand.ExecuteNonQuery();
                conn.Close();
                da.UpdateCommand = new OdbcCommand("UPDATE " + dateTableName + " SET ID='" + tbxUpdateID.Text.Trim() + "' WHERE ID='" + textBoxID.Text.Trim() + "'", conn);
                conn.Open();
                da.UpdateCommand.ExecuteNonQuery();
                conn.Close();
                textBoxID.Text = tbxUpdateID.Text.Trim();
                if (openSLornot == false)//if the student list table is now open
                {
                    sl.dgView.CurrentRow.Cells["ID"].Value = tbxUpdateID.Text.Trim();
                }
                MessageBox.Show("ID Updated!", "Infomation", MessageBoxButtons.OK, MessageBoxIcon.Information);
                tbxUpdateID.Text = null;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                if (conn.State == ConnectionState.Open)
                { conn.Close(); }
                tbxUpdateID.SelectAll();
                tbxUpdateID.Focus();
            }
        }

        //add new appointment (inside add appointment tag)
        private void btnOK_AddNewAppointment_Click(object sender, EventArgs e)
        {
            string newAppointment = dateTimePicker1.Value.Year + "-" + dateTimePicker1.Value.Month + "-" + dateTimePicker1.Value.Day;
            //MessageBox.Show(newAppointment);
            if (newAppointment != getTodayDate())
            {
                try
                {
                    com = new OdbcCommand("SELECT * FROM " + dateTableName + " WHERE ID='" + textBoxID.Text.Trim() + "' AND date='" + newAppointment + "'", conn);
                    da = new OdbcDataAdapter(com);
                    dt = new DataTable();
                    da.Fill(dt);
                    if (dt.Rows.Count == 0)
                    {
                        da.InsertCommand = new OdbcCommand("INSERT INTO " + dateTableName + "(date,ID) VALUES('" + newAppointment+"','" + textBoxID.Text.Trim() + "')", conn);
                        conn.Open();
                        da.InsertCommand.ExecuteNonQuery();
                        conn.Close();
                        MessageBox.Show("New appointment added!", "Infomation", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        ShowDateInformation();
                        CountPersonalAttendance();
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    if (conn.State == ConnectionState.Open)
                    { conn.Close(); }
                }
            }
        }

        //delete an appointment
        private void btnDelete_Appointment_Click(object sender, EventArgs e)
        {
            btnDelete_Appointment.Enabled = true;
            DialogResult result = MessageBox.Show("Are you sure you want to delete this appointment?", "Question", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if (result == DialogResult.Yes)
            {
                string deleteAppointment = tbxDeleteDate.Text.Substring(0, 10);
                try
                {
                    com = new OdbcCommand("DELETE FROM " + dateTableName + " WHERE ID='" + textBoxID.Text.Trim() + "' AND date='" + deleteAppointment + "'", conn);
                    conn.Open();
                    com.ExecuteNonQuery();
                    conn.Close();
                    ShowDateInformation();
                    CountPersonalAttendance();
                    if (deleteAppointment == DateTime.Today.ToShortDateString())
                    {
                        ShowDayPersonCount();
                    }
                    
                }
                catch (Exception ex)
                {
                    errorMessage = ex.Message;
                    MessageBox.Show("This student did not attend on " + deleteAppointment, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    if (conn.State == ConnectionState.Open)
                    { conn.Close(); }
                } 
            }
            tbxDeleteDate.Text = null;
            btnDelete_Appointment.Enabled = false;
        }

        //load table of course result
        private void tabControl1_Selected(object sender, TabControlEventArgs e)
        {
            if (tabControl1.SelectedIndex == 3)
            {
                toolTip_BarcodeCount.SetToolTip(this.btnExportFailedstu, "Export Failed student list");
                btnCourseResult_Click(null, null);
            }
            else if (tabControl1.SelectedIndex == 2)
            {
                dateTimePicker1.Text = DateTime.Today.ToShortDateString();
            }
        }

        //show result (inside Course result tag)
        private void btnCourseResult_Click(object sender, EventArgs e)
        {
            try
            {
                com = new OdbcCommand("SELECT id, FirstName, LastName, StudentNumber FROM " + stuTableName, conn);
                da = new OdbcDataAdapter(com);
                dt = new DataTable();
                da.Fill(dt);
                dt.Columns.Add("Result", typeof(Char));
                dt.Columns["Result"].DefaultValue = '-';
                string idValue;
                DataTable dtAttendance;
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    idValue = dt.Rows[i]["ID"].ToString();
                    com = new OdbcCommand("SELECT date FROM " + dateTableName + " WHERE ID='" + idValue + "'", conn);
                    da = new OdbcDataAdapter(com);
                    dtAttendance = new DataTable();
                    da.Fill(dtAttendance);
                    if (dtAttendance.Rows.Count >= int.Parse(minAttendNum.Value.ToString()))
                    {
                        dt.Rows[i]["Result"] = '+';
                    }
                    else
                    {
                        dt.Rows[i]["Result"] = '-';
                    }
                }
                tblBS_CourseResult = new BindingSource();
                tblBS_CourseResult.DataSource = dt;
                dgView_Result.DataSource = tblBS_CourseResult;
                dgView_Result.Columns["Result"].Width = 60;
                bindingNavigatorResult.BindingSource = tblBS_CourseResult;
                dgView_Result.Focus();
                btnExportFailedstu.Enabled = false;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                if (conn.State == ConnectionState.Open)
                { conn.Close(); }
            }
        }

        //filter out who didn't pass the course
        private void btnFilterResult_Click(object sender, EventArgs e)
        {
            tblBS_CourseResult.Filter = "Result = '-'";
            btnExportFailedstu.Enabled = true;
        }
        
        //export failed student list
        private void btnExportFailedstu_Click(object sender, EventArgs e)
        {
            try
            {
                string saveFileName;
                saveFileDialogFailedStudents.FileName = "Failed Students (" + comboBoxCourseList.Text + ")";
                if (saveFileDialogFailedStudents.ShowDialog() == DialogResult.OK)
                {
                    saveFileName = saveFileDialogFailedStudents.FileName;
                    StreamWriter sw = new StreamWriter(saveFileName);
                    sw.WriteLine("Course: "+this.comboBoxCourseList.Text);
                    sw.WriteLine("Failed students:");
                    string records;
                    for (int i = 0; i < dgView_Result.Rows.Count; i++)
                    {
                        records = "";
                        for (int j = 0; j < dgView_Result.Columns.Count-1; j++)
                        {
                            records = records + dgView_Result.Rows[i].Cells[j].Value.ToString() + "  ";
                        }
                        sw.WriteLine(records);
                    }
                    sw.Close();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
        }

        //close the whole program
        private void BarcodeCounter_FormClosed(object sender, FormClosedEventArgs e)
        {
            parForm.Close();//parForm is Login.form, close Login.form
        }



        
    }
}
