﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.Odbc;

namespace BarCodeScanner
{
    public partial class CreateTables : Form
    {
        OdbcCommand com;
        OdbcConnection conn;
        OdbcDataAdapter da = new OdbcDataAdapter();
        Form parForm;//parent form
        string errorMessage;
        string courseName;

        public CreateTables(Form f, string conns)//parent form , connection string as params
        {
            conn = new OdbcConnection(conns);//a new Odbc Connection
            parForm = f;
            InitializeComponent();
        }

        private void btnCreate_Click(object sender, EventArgs e)
        {
            courseName = textBoxCourse.Text.Trim();
            try
            {
                com = conn.CreateCommand();
                com.CommandText = "CREATE TABLE stu_" + courseName + "(id BIGINT NOT NULL,FirstName VARCHAR(45) NULL,LastName VARCHAR(45) NULL,StudentNumber INT NOT NULL,Email VARCHAR(45) NULL,ContactPhone VARCHAR(45) NULL,Age INT(3) NULL,Gender VARCHAR(10),PRIMARY KEY (id), UNIQUE INDEX id_UNIQUE(id ASC),UNIQUE INDEX StudentNumber_UNIQUE(StudentNumber ASC));";
                conn.Open();
                com.ExecuteNonQuery();
                conn.Close();

                com.CommandText = "CREATE TABLE date_" + courseName + "(serial BIGINT NOT NULL AUTO_INCREMENT,date DATE NOT NULL,ID BIGINT NOT NULL,UNIQUE INDEX serial_UNIQUE(serial ASC))";
                conn.Open();
                com.ExecuteNonQuery();
                conn.Close();
                this.Close();//close this form

            }
            catch (Exception ex)//exception catched, means table already existed
            {
                errorMessage = ex.Message;
                MessageBox.Show("This course exists in your database!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                if (conn.State == ConnectionState.Open)
                {
                    conn.Close();
                }
            }
            
        }

        private void CreateTables_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
            parForm.Show();
        }

        private void btnCancel_addNewCourse_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void CreateTables_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                this.btnCreate.PerformClick();
            }

        }
    }
}
