﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace BarCodeScanner
{
    public partial class Remarks : Form
    {
        Form parForm;

        public Remarks(Form f)
        {
            parForm = f;
            InitializeComponent();
        }

        private void btnOK_ForgetCardList_Click(object sender, EventArgs e)
        {
            this.Hide();
        }

        private void btnExportForgetCardStud_Click(object sender, EventArgs e)
        {
            try
            {
                if (saveForgetCardStud.ShowDialog() == DialogResult.OK && saveForgetCardStud.FileName.Length>0)
                {
                    tbxForgetCardStudent.SaveFile(saveForgetCardStud.FileName,RichTextBoxStreamType.PlainText);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
        }

        private void ForgetCardList_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        private void ForgetCardList_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.E && e.Control)
            {
                this.btnExportForgetCardStud.PerformClick();
            }
            else if (e.KeyCode == Keys.Enter)
            {
                this.btnOK_ForgetCardList.PerformClick() ;
            }
            
        }

      
    }
}
