﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.Odbc;
using System.IO;

namespace BarCodeScanner
{
    public partial class StudentList : Form
    {
        string connStr;
        BindingSource tblBS;
        BarcodeCounter parForm;
        OdbcCommand com;
        OdbcConnection conn;
        OdbcDataAdapter da;
        DataTable dt;
        string stuTableName;
        string dateTableName;
        string courseName;
        string idContent;//content of ID
        Boolean valueChanged = false;//control save or not
        Boolean isExistStud = false;//whether this record exist or not
        
        public StudentList(BarcodeCounter f,string s,string s2)//params:BarcodeCounter.cs, connection string,course name
        {
            parForm = f;
            connStr = s;
            conn = new OdbcConnection(connStr);
            courseName = s2;
            stuTableName = "stu_" + courseName;
            dateTableName = "date_" + courseName;
            InitializeComponent();
        }

        //build connection between StudentList.cs and BarcodeCounter.cs
        private void StudentList_Load(object sender, EventArgs e)
        {
            this.tblBS = parForm.tblBS;
            bindingNavigator1.BindingSource = this.tblBS;
            dgView.DataSource = tblBS;

            dgView.Columns["id"].ReadOnly = true;
            dgView.Sort(dgView.Columns["firstname"], ListSortDirection.Ascending);
        }

        //rebinding the public BindingSource tblBS to 4 information textboxes in BarcodeCounter.cs
        private void bindingNavigator1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            parForm.BindingTextBox();
        }
        //rebinding the public BindingSource tblBS to 4 information textboxes in BarcodeCounter.cs
        private void dgView_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            parForm.BindingTextBox();
        }

        private void toolStripBtnSave_Click(object sender, EventArgs e)
        {
            addRecords();
            updateRecords();
            toolStripBtnSave.Enabled = false;
            valueChanged = false;            
        }

        private string[] getUpdatedValue(int i)
        {
            string [] values = new string[8];
            values[0] = "'" + dgView.Rows[i].Cells["ID"].Value.ToString().Trim() + "'";
            values[1] = "'" + dgView.Rows[i].Cells["FirstName"].Value.ToString().Trim() + "'";
            values[2] = "'" + dgView.Rows[i].Cells["LastName"].Value.ToString().Trim() + "'";
            values[3] = "'" + dgView.Rows[i].Cells["StudentNumber"].Value.ToString().Trim() + "'";
            values[4] = "'" + dgView.Rows[i].Cells["Email"].Value.ToString().Trim() + "'";
            values[5] = "'" + dgView.Rows[i].Cells["ContactPhone"].Value.ToString().Trim() + "'";
            values[6] = "'" + dgView.Rows[i].Cells["Age"].Value.ToString().Trim() + "'";
            values[7] = "'" + dgView.Rows[i].Cells["Gender"].Value.ToString().Trim() + "'";
            if (values[1] == "''") { values[1] = "NULL"; }
            if (values[2] == "''") { values[2] = "NULL"; }
            if (values[3] == "''") { values[3] = "NULL"; }
            if (values[6] == "''") { values[6] = "NULL"; }
            if (values[4] == "''") { values[4] = "NULL"; }
            if (values[5] == "''") { values[5] = "NULL"; }
            if (values[7] == "''") { values[7] = "NULL"; }
            return values;
        }

        //add new records to MySQL database
        private void addRecords()
        {
            try
            {
                for (int i = 0; i < dgView.Rows.Count; i++)
                {
                    //remove the rows with null ID
                    if (dgView.Rows[i].Cells[0].Value.ToString().Trim() == "")
                    {
                        dgView.Rows.RemoveAt(i);
                    }
                }

                //check whether there are new students added
                com = new OdbcCommand("SELECT count(ID) FROM " + stuTableName, conn);
                da = new OdbcDataAdapter(com);
                dt = new DataTable();
                da.Fill(dt);
                if (this.tblBS.Count.ToString() != dt.Rows[0][0].ToString())//some new records added
                {
                    com = new OdbcCommand("SELECT ID FROM " + stuTableName, conn);
                    da = new OdbcDataAdapter(com);
                    dt = new DataTable();
                    da.Fill(dt);
                    for (int i = 0; i < dgView.Rows.Count; i++)
                    {
                        idContent = dgView.Rows[i].Cells[0].Value.ToString().Trim();
                        for (int j = 0; j < dt.Rows.Count; j++)
                        {
                            if (idContent == dt.Rows[j][0].ToString())
                            {
                                isExistStud = true;//has exist this student
                            }

                        }
                        if (isExistStud == false)
                        {
                            //student record does not exist
                            //add to database
                            string[] values;
                            values=getUpdatedValue(i);
                            da.InsertCommand = new OdbcCommand
                                    ("INSERT INTO " + stuTableName + " VALUES (" + values[0] + "," + values[1] + "," + values[2] + "," + values[3] + "," + values[4] + "," + values[5] + "," + values[6] + "," + values[7] + ")", conn);
                            conn.Open();
                            da.InsertCommand.ExecuteNonQuery();
                            conn.Close();
                        }
                        isExistStud = false;
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                if (conn.State == ConnectionState.Open)
                {
                    conn.Close();
                }
            }
        }

        //update new records to MySQL database
        private void updateRecords()
        {
            for (int i=0; i < dgView.RowCount; i++)
            {
                string[] values;
                values = getUpdatedValue(i);
                try
                {
                    da.UpdateCommand = new OdbcCommand("UPDATE " + stuTableName + " SET FirstName=" + values[1] + ",LastName=" + values[2] + ",StudentNumber="+values[3]+",Email=" + values[4] + ",ContactPhone=" + values[5] + ",Age=" + values[6] + ",Gender=" + values[7] + " WHERE ID=" + values[0] + "", conn);
                    conn.Open();
                    da.UpdateCommand.ExecuteNonQuery();
                    conn.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    if (conn.State == ConnectionState.Open)
                    {
                        conn.Close();
                    }
                }
            }

        }

        //when closing form, dialog save data or not
        private void StudentList_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (valueChanged == true)
            {
                DialogResult r = MessageBox.Show("Do you want to save the changes?", "Question", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);
                if (r == DialogResult.Yes)
                {
                    addRecords();
                    updateRecords();
                    parForm.openSLornot = true;
                    parForm.btnStudentList.Text = "&Open List";
                }
                else if (r == DialogResult.No)
                {
                    toolStripBtnSave.Enabled = false;
                    valueChanged = false;
                    this.Close();
                    parForm.BindingData();
                    parForm.openSLornot = true;
                    parForm.btnStudentList.Text = "&Open List";
                }
                else
                { e.Cancel = true; }
            }
            else
            {
                parForm.openSLornot = true;
                parForm.btnStudentList.Text = "&Open List";
            }
        }

        private void dgView_CellValueChanged(object sender, DataGridViewCellEventArgs e)
        {
            toolStripBtnSave.Enabled = true;
            valueChanged = true;
        }

        //add records
        private void bindingNavigatorAddNewItem_Click(object sender, EventArgs e)
        {
            dgView.Rows[dgView.Rows.Count - 1].Cells["id"].Selected=true;
            dgView.Columns["id"].ReadOnly = false;
            dgView.Columns["StudentNumber"].ReadOnly = false;
            for (int i = 0; i < dgView.RowCount - 1; i++)
            {
                dgView.Rows[i].Cells["id"].ReadOnly = true;
                dgView.Rows[i].Cells["StudentNumber"].ReadOnly = true;
            }
            toolStripBtnSave.Enabled = true;
            valueChanged = true;
            //press add button sequently is not allowed
            bindingNavigatorAddNewItem.Enabled = false;
        }

        private void dgView_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {
            bindingNavigatorAddNewItem.Enabled = true;
        }

        //delete record
        private void bindingNavigatorDeleteItem_Click(object sender, EventArgs e)
        {
            try
            {
                DialogResult r = MessageBox.Show("Are you sure you want to delete this record?", "Question", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (r == DialogResult.Yes)
                {
                    com = new OdbcCommand("DELETE FROM " + stuTableName + " WHERE ID='" + parForm.textBoxID.Text + "'", conn);
                    conn.Open();
                    com.ExecuteNonQuery();
                    conn.Close();
                    com = new OdbcCommand("DELETE FROM " + dateTableName + " WHERE ID='" + parForm.textBoxID.Text + "'", conn);
                    conn.Open();
                    com.ExecuteNonQuery();
                    conn.Close();
                    
                    parForm.tblBS.RemoveCurrent();
                }
                toolStripBtnSave.Enabled = true;
                valueChanged = true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                if (conn.State == ConnectionState.Open)
                { conn.Close(); }
            }
        }

        //import records from txt file
        private void toolStripBtnImport_Click(object sender, EventArgs e)
        {
            if (openStudentListFile.ShowDialog() == DialogResult.OK)
            {
                int readlineCount = 0;
                string openFileName = openStudentListFile.FileName;
                StreamReader sr = new StreamReader(openFileName);
                while (sr.Peek() >= 0)
                {
                    string[] data = sr.ReadLine().Split(';');
                    string[] stuImportedData = new string[8];
                    try
                    {
                        if (data[0] != "")// not an empty line
                        {
                            if (data.Length >= 8)
                            {
                                for (int i = 0; i < 8; i++)
                                {
                                    stuImportedData[i] = data[i];
                                }
                            }
                            else if (data.Length < 8)
                            {
                                for (int i = 0; i < data.Length; i++)
                                {
                                    stuImportedData[i] = data[i];
                                }
                            }
                            for (int i = 0; i < 8; i++)
                            {
                                if (stuImportedData[i] == "" || string.Compare(stuImportedData[i],"null",true)==0)
                                {
                                    stuImportedData[i] = null;
                                }
                            }
                            parForm.ds.Tables["StudentList"].Rows.Add(stuImportedData);
                            parForm.tblBS.DataSource = parForm.ds.Tables["StudentList"];
                            this.tblBS = parForm.tblBS;
                            bindingNavigator1.BindingSource = tblBS;
                            dgView.DataSource = tblBS;
                            toolStripBtnSave.Enabled = true;
                            valueChanged = true;
                        }
                        readlineCount++;
                    }
                    catch (Exception ex)
                    {
                        readlineCount++;
                        MessageBox.Show("Error occured at line " + readlineCount + "!\nError message: " + ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                }
                sr.Close();
            }  
        }

        //when change selection of datagridview, the information in barcodeCounter.cs also change
        private void dgView_SelectionChanged(object sender, EventArgs e)
        {
            //update date datagridview
            parForm.ShowDateInformation();
            //change personal attendance
            parForm.CountPersonalAttendance();
            //change total Student Number
            parForm.ShowDayPersonCount();
        }

        //filter data
        private void tblFilter_TextChanged(object sender, EventArgs e)
        {
            string findText = tbxFilter.Text;
            int rowIndexFromFind = dgView.CurrentRow.Index;
            for (int i = 0; i < dgView.Rows.Count; i++)
            {
                if (dgView.Rows[i].Cells["FirstName"].Value.ToString().StartsWith(findText))
                {
                    rowIndexFromFind = i;
                    dgView.CurrentCell = dgView.Rows[rowIndexFromFind].Cells["FirstName"];
                    break;
                }
            }
        }

        //capture errors
        private void dgView_DataError(object sender, DataGridViewDataErrorEventArgs e)
        {
            if (e.Exception != null)
            {
                MessageBox.Show(string.Format("Error occurs.\n\nError Information: {0}", e.Exception.Message), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                e.Cancel = true;
                
                for (int i = 0; i < dgView.Rows.Count; i++)
                {
                    //remove the rows with null id
                    if (dgView.Rows[i].Cells[0].Value.ToString().Trim() == "")
                    {
                        dgView.Rows.RemoveAt(i);
                    }
                }
            } 
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            toolStripBtnSave_Click(null, null);
        }
        private void CloseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        private void addToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bindingNavigatorAddNewItem_Click(null, null);
        }
        private void deleteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bindingNavigatorDeleteItem_Click(null, null);
        }

        //Import student list
        private void ImportToolStripMenuItem_Click(object sender, EventArgs e)
        {
            toolStripBtnImport_Click(null, null);
        }
        
        //export whole Student list
        private void studentListToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveStudentList.FileName = courseName+"_Student List";
            if (saveStudentList.ShowDialog() == DialogResult.OK && saveStudentList.FileName.Length>0)
            {
                try
                {
                    string saveFileName = saveStudentList.FileName;
                    StreamWriter sw = new StreamWriter(saveFileName);
                    string recordLine;
                    for (int i = 0; i < dgView.Rows.Count; i++)
                    {
                        recordLine = "";
                        for (int j = 0; j < dgView.Columns.Count; j++)
                        {
                            recordLine = recordLine + dgView.Rows[i].Cells[j].Value.ToString() + ";";
                        }
                        sw.WriteLine(recordLine);
                    }
                    sw.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
            }
        }

        //export email list
        private void emailToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveStudentList.FileName = courseName + "_email";
            if (saveStudentList.ShowDialog() == DialogResult.OK && saveStudentList.FileName.Length>0)
            {
                try
                {
                    string saveFileName = saveStudentList.FileName;
                    StreamWriter sw = new StreamWriter(saveFileName);
                    sw.WriteLine("Course: " + courseName);
                    sw.WriteLine("Students' Email:");
                    string recordLine="";
                    for (int i = 0; i < dgView.Rows.Count; i++)
                    {
                        recordLine=dgView.Rows[i].Cells["Email"].Value.ToString();
                        if(recordLine!="")
                        {
                            sw.WriteLine(recordLine);
                        }
                    }
                    sw.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
            }
        }

        //export students' name list
        private void naToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveStudentList.FileName = courseName + "_name";
            if (saveStudentList.ShowDialog() == DialogResult.OK && saveStudentList.FileName.Length>0)
            {
                try
                {
                    string saveFileName = saveStudentList.FileName;
                    StreamWriter sw = new StreamWriter(saveFileName);
                    sw.WriteLine("Course: " + courseName);
                    sw.WriteLine("Name list:");
                    string recordLine = "";
                    for (int i = 0; i < dgView.Rows.Count; i++)
                    {
                        recordLine = dgView.Rows[i].Cells["Firstname"].Value.ToString() + ", " + dgView.Rows[i].Cells["Lastname"].Value.ToString();
                        if (recordLine != "")
                        {
                            sw.WriteLine(recordLine);
                        }
                    }
                    sw.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message,"Warning",MessageBoxButtons.OK,MessageBoxIcon.Warning);
                }
            }
        }

        //tool tips
        private void toolStripBtnImport_MouseHover(object sender, EventArgs e)
        {
            toolTip_StudentList.SetToolTip(this.bindingNavigator1, "Import records");
        }
        private void bindingNavigatorDeleteItem_MouseHover(object sender, EventArgs e)
        {
            toolTip_StudentList.SetToolTip(this.bindingNavigator1, "Delete record(s)");
        }
        private void bindingNavigatorAddNewItem_MouseHover(object sender, EventArgs e)
        {
            toolTip_StudentList.SetToolTip(this.bindingNavigator1, "Add new record(s)");
        }

        
    }
}
